Index: tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/commands/function/BackToMedia.java
===================================================================
--- tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/commands/function/BackToMedia.java	(revision 672)
+++ tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/commands/function/BackToMedia.java	(revision 673)
@@ -57,7 +57,7 @@
 public class BackToMedia extends AbstractHandler {
 
 	/** The ID. */
-	public static String ID = "org.txm.rcpapplication.commands.BackToMedia"; //$NON-NLS-1$
+	public static String ID = "org.txm.rcp.commands.BackToMedia"; //$NON-NLS-1$
 
 	/** The selection. */
 	private IStructuredSelection selection;
Index: tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/commands/function/OpenVLCPlayer.java
===================================================================
--- tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/commands/function/OpenVLCPlayer.java	(revision 672)
+++ tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/commands/function/OpenVLCPlayer.java	(revision 673)
@@ -55,7 +55,7 @@
 public class OpenVLCPlayer extends AbstractHandler {
 
 	/** The ID. */
-	public static String ID = "org.txm.rcpapplication.commands.BackToMedia"; //$NON-NLS-1$
+	public static String ID = "org.txm.rcp.commands.BackToMedia"; //$NON-NLS-1$
 
 	/** The selection. */
 	private IStructuredSelection selection;
Index: tmp/org.txm.dictionary.rcp/src/org/txm/macro/frolex/DMFSite2CLDMFTSVMacro.groovy
===================================================================
--- tmp/org.txm.dictionary.rcp/src/org/txm/macro/frolex/DMFSite2CLDMFTSVMacro.groovy	(revision 672)
+++ tmp/org.txm.dictionary.rcp/src/org/txm/macro/frolex/DMFSite2CLDMFTSVMacro.groovy	(revision 673)
@@ -14,7 +14,7 @@
 
 import org.kohsuke.args4j.*
 import groovy.transform.Field
-import org.txm.rcpapplication.swt.widget.parameters.*
+import org.txm.rcp.swt.widget.parameters.*
 
 // PARAMETERS
 @Field @Option(name="workingDirectory", usage="workingDirectory containing all files needed", widget="Folder", required=true, def="dir")
Index: tmp/org.txm.dictionary.rcp/src/org/txm/macro/frolex/MergeCLDMFLEXSMacro.groovy
===================================================================
--- tmp/org.txm.dictionary.rcp/src/org/txm/macro/frolex/MergeCLDMFLEXSMacro.groovy	(revision 672)
+++ tmp/org.txm.dictionary.rcp/src/org/txm/macro/frolex/MergeCLDMFLEXSMacro.groovy	(revision 673)
@@ -13,7 +13,7 @@
 
 import org.kohsuke.args4j.*
 import groovy.transform.Field
-import org.txm.rcpapplication.swt.widget.parameters.*
+import org.txm.rcp.swt.widget.parameters.*
 
 // PARAMETERS
 @Field @Option(name="workingDirectory", usage="workingDirectory containing all files needed", widget="Folder", required=true, def="dir")
Index: tmp/org.txm.dictionary.rcp/src/org/txm/macro/frolex/CreateFrolexMacro.groovy
===================================================================
--- tmp/org.txm.dictionary.rcp/src/org/txm/macro/frolex/CreateFrolexMacro.groovy	(revision 672)
+++ tmp/org.txm.dictionary.rcp/src/org/txm/macro/frolex/CreateFrolexMacro.groovy	(revision 673)
@@ -11,7 +11,7 @@
 
 import org.kohsuke.args4j.*
 import groovy.transform.Field
-import org.txm.rcpapplication.swt.widget.parameters.*
+import org.txm.rcp.swt.widget.parameters.*
 
 import org.txm.Toolbox
 import org.txm.dictionary.functions.sql.Dictionary
Index: tmp/org.txm.dictionary.rcp/src/org/txm/macro/frolex/LGerm2CLDMFTSVMacro.groovy
===================================================================
--- tmp/org.txm.dictionary.rcp/src/org/txm/macro/frolex/LGerm2CLDMFTSVMacro.groovy	(revision 672)
+++ tmp/org.txm.dictionary.rcp/src/org/txm/macro/frolex/LGerm2CLDMFTSVMacro.groovy	(revision 673)
@@ -18,7 +18,7 @@
 
 import org.kohsuke.args4j.*
 import groovy.transform.Field
-import org.txm.rcpapplication.swt.widget.parameters.*
+import org.txm.rcp.swt.widget.parameters.*
 
 // PARAMETERS
 @Field @Option(name="workingDirectory", usage="workingDirectory containing all files needed", widget="Folder", required=true, def="dir")
Index: tmp/org.txm.querycooccurrences.rcp/src/org/txm/rcp/commands/function/ComputeQueryAutoCooccurrence.java
===================================================================
--- tmp/org.txm.querycooccurrences.rcp/src/org/txm/rcp/commands/function/ComputeQueryAutoCooccurrence.java	(revision 0)
+++ tmp/org.txm.querycooccurrences.rcp/src/org/txm/rcp/commands/function/ComputeQueryAutoCooccurrence.java	(revision 673)
@@ -0,0 +1,356 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate:$
+// $LastChangedRevision:$
+// $LastChangedBy:$ 
+//
+package org.txm.rcp.commands.function;
+
+import java.io.File;
+import java.util.ArrayList;
+
+import org.eclipse.core.commands.AbstractHandler;
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
+import org.eclipse.jface.dialogs.Dialog;
+import org.eclipse.jface.viewers.IStructuredSelection;
+import org.eclipse.jface.window.Window;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.events.SelectionEvent;
+import org.eclipse.swt.events.SelectionListener;
+import org.eclipse.swt.graphics.GC;
+import org.eclipse.swt.layout.GridData;
+import org.eclipse.swt.layout.GridLayout;
+import org.eclipse.swt.widgets.Button;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Control;
+import org.eclipse.swt.widgets.FileDialog;
+import org.eclipse.swt.widgets.Label;
+import org.eclipse.swt.widgets.Shell;
+import org.eclipse.swt.widgets.Spinner;
+import org.eclipse.ui.handlers.HandlerUtil;
+import org.txm.functions.coocmatrix.QueryAutoCooccurrence;
+import org.txm.functions.queryindex.QueryIndex;
+import org.txm.functions.queryindex.QueryIndexLine;
+import org.txm.rcp.JobsTimer;
+import org.txm.rcp.RCPMessages;
+import org.txm.rcp.utils.JobHandler;
+import org.txm.rcp.views.QueriesView;
+import org.txm.rcp.views.corpora.CorporaView;
+import org.txm.searchengine.cqp.CQPEngine;
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.StructuralUnit;
+import org.txm.searchengine.cqp.corpus.query.Query;
+import org.txm.stat.utils.ConsoleProgressBar;
+import org.txm.statsengine.r.rcp.views.RVariablesView;
+//import org.txm.functions.queryindex.*;
+import org.txm.utils.logger.Log;
+
+/**
+ * if the selection is a corpus, open an empty Cooc editor if the selection is a
+ * concordance, open a Cooc editor already computed @ author mdecorde.
+ */
+public class ComputeQueryAutoCooccurrence extends AbstractHandler {
+
+	float reqtime = 0.5f;
+
+	/* (non-Javadoc)
+	 * @see org.eclipse.core.commands.AbstractHandler#execute(org.eclipse.core.commands.ExecutionEvent)
+	 */
+	@Override
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+		IStructuredSelection selection = (IStructuredSelection) HandlerUtil.getCurrentSelection(event);
+		final Object element = selection.getFirstElement();
+
+		final Shell shell = HandlerUtil.getActiveWorkbenchWindowChecked(event)
+				.getShell();
+
+		JobHandler jobhandler = new JobHandler("Computing cooccurrences matrix") {
+			@Override
+			protected IStatus run(IProgressMonitor monitor) {
+				this.runInit(monitor);
+				try {
+					JobsTimer.start();
+
+					if (!(element instanceof QueryIndex)) {
+						System.out.println(RCPMessages.ComputeCooccurrences_1+ element);
+						return Status.CANCEL_STATUS;
+					}
+					QueryIndex qi = ((QueryIndex)element);
+					Corpus corpus = qi.getCorpus();
+					
+					final CoocMatrixDialog dialog = new ComputeQueryAutoCooccurrence.CoocMatrixDialog(shell, corpus);
+					syncExec(new Runnable() {
+						@Override
+						public void run() {
+							dialog.open();
+						}
+					});
+
+					if (dialog.getReturnCode() != Window.OK) System.out.println("Canceled");
+
+					this.acquireSemaphore();
+					final QueryAutoCooccurrence cooc = computeCooc(shell, corpus, (QueryIndex)element, dialog);
+					this.releaseSemaphore();
+
+					if (cooc == null) return null;
+					
+					System.out.println(RCPMessages.ComputeCoocMatrix_0+cooc.getSymbol());
+
+					syncExec(new Runnable() {
+						@Override
+						public void run() {
+							CorporaView.refresh();
+							CorporaView.expand(cooc.getCorpus());
+							QueriesView.refresh();
+							RVariablesView.refresh();
+						}
+					});
+				} catch (ThreadDeath td) { 
+					return Status.CANCEL_STATUS;
+				} catch (Exception e) {
+					Log.printStackTrace(e);
+					try { System.out.println(RCPMessages.LastCQPError+CQPEngine.getCqiClient().getLastCQPError());
+					} catch (Exception e1) { e1.printStackTrace(); }
+				} finally {
+					monitor.done();
+					JobsTimer.stopAndPrint();
+				}
+				return Status.OK_STATUS;
+			}
+		};
+		jobhandler.startJob();
+		return null;
+	}
+
+
+	private QueryAutoCooccurrence computeCooc(Shell shell, Corpus corpus, QueryIndex element, CoocMatrixDialog dialog) {
+		ArrayList<Query> queries = new ArrayList<Query>();
+		ArrayList<String> names = new ArrayList<String>();
+
+		String struct = dialog.getStruct();
+		int dist = dialog.getDist();
+		int min = dialog.getMin();
+		File outfile = dialog.getOutFile();
+		boolean oriented = dialog.getOriented();
+
+		for (QueryIndexLine line : element.getLines()) {
+			queries.add(line.getQuery());
+			names.add(line.getName());
+		}
+
+		System.out.println(RCPMessages.ProgressionDialog_8+queries);
+		System.out.println(RCPMessages.MergeCols_5+names);
+
+		QueryAutoCooccurrence cooc = null;
+		try {
+
+			int nqueries = (queries.size()*queries.size()/2);
+			System.out.println("Number of queries: "+nqueries);
+			System.out.println("Estimated time: "+(nqueries*reqtime/1000)+" secs");
+			cooc = new QueryAutoCooccurrence(corpus);
+			cooc.setParameters(queries, names, dist, min, struct, oriented, new ConsoleProgressBar(nqueries));
+			System.out.println(RCPMessages.ComputeCoocMatrix_1+cooc.getNNodes());
+			System.out.println(RCPMessages.ComputeCoocMatrix_2+cooc.getNEdges());
+			System.out.println(RCPMessages.ComputeCoocMatrix_3+dist);
+
+			if (outfile != null) {
+				cooc.toGraphml(outfile);
+				System.out.println(RCPMessages.ComputeCoocMatrix_4+outfile);
+			}
+
+		} catch (Exception e) {
+			Log.printStackTrace(e);
+			try { System.out.println(RCPMessages.LastCQPError+CQPEngine.getCqiClient().getLastCQPError());
+			} catch (Exception e1) { e1.printStackTrace(); }
+		}
+		return cooc;
+	}
+
+	public class CoocMatrixDialog extends Dialog {
+		Corpus corpus;
+
+		org.eclipse.swt.widgets.List propsCombo;
+		Spinner distSpinner;
+		Spinner minSpinner;
+		Label outfileLabel;
+
+		File outfile;
+		int dist;
+		int min;
+		String struct;
+		private boolean oriented;
+
+		private Button orientedButton;
+
+		public CoocMatrixDialog(Shell parentShell, Corpus corpus) {
+			super(parentShell);
+			this.setShellStyle(this.getShellStyle() | SWT.RESIZE);
+			this.corpus = corpus;
+		}
+
+
+		public boolean getOriented() {
+			return oriented;
+		}
+
+
+		/* (non-Javadoc)
+		 * @see org.eclipse.jface.window.Window#configureShell(org.eclipse.swt.widgets.Shell)
+		 */
+		@Override
+		protected void configureShell(Shell newShell) {
+			super.configureShell(newShell);
+			newShell.setText(RCPMessages.ComputeCoocMatrix_7);
+		}
+
+		/* (non-Javadoc)
+		 * @see org.eclipse.jface.dialogs.Dialog#createDialogArea(org.eclipse.swt.widgets.Composite)
+		 */
+		@Override
+		protected Control createDialogArea(Composite parent) {
+			Composite composite = parent; //new Composite(parent, SWT.NONE);
+			// TODO : we just put a composite into another composite. Everything
+			// should be directly put into parent
+			GridLayout layout = new GridLayout(2, false);
+			composite.setLayout(layout);
+
+			Label anaPropLabel = new Label(composite, SWT.NONE);
+			anaPropLabel.setText(RCPMessages.ParaBrowserEditor_5);
+			anaPropLabel.setLayoutData(new GridData(GridData.END, GridData.CENTER, false, false));
+
+			propsCombo = new org.eclipse.swt.widgets.List(composite, SWT.READ_ONLY);
+			GridData gdata = new GridData(GridData.FILL, GridData.FILL, true, false);
+			propsCombo.setLayoutData(gdata);
+			GC gc = new GC(propsCombo);
+			gc.setFont(this.propsCombo.getFont());
+			gdata.heightHint = gc.getFontMetrics().getHeight() * 5;
+			gc.dispose();
+			propsCombo.add("");
+			try {
+				for (StructuralUnit p : corpus.getStructuralUnits()) {
+					if (!("text".equals(p.getName()) ||  //$NON-NLS-1$
+							"txmcorpus".equals(p.getName()))) //$NON-NLS-1$
+						propsCombo.add(p.getName());
+				}
+			} catch (CqiClientException e) {
+				Log.printStackTrace(e);
+				return parent;
+			}
+
+			Label distLabel = new Label(composite, SWT.NONE);
+			distLabel.setText(RCPMessages.ComputeCoocMatrix_10);
+			distLabel.setLayoutData(new GridData(GridData.END, GridData.CENTER,
+					false, false));
+			distSpinner = new Spinner(composite, SWT.BORDER);
+			distSpinner.setMinimum(0);
+			distSpinner.setMaximum(1000);
+			distSpinner.setSelection(10);
+
+			Label minLabel = new Label(composite, SWT.NONE);
+			minLabel.setText(RCPMessages.ComputeCoocMatrix_11);
+			minLabel.setLayoutData(new GridData(GridData.END, GridData.CENTER,
+					false, false));
+			minSpinner = new Spinner(composite, SWT.BORDER);
+			minSpinner.setMinimum(1);
+			minSpinner.setMaximum(1000);
+			minSpinner.setSelection(20);
+			
+			Label orientedLabel = new Label(composite, SWT.NONE);
+			orientedLabel.setText("Oriented");
+			orientedLabel.setLayoutData(new GridData(GridData.END, GridData.CENTER,
+					false, false));
+			orientedButton = new Button(composite, SWT.CHECK);
+			orientedButton.setSelection(false);
+
+			outfileLabel = new Label(composite, SWT.NONE);
+			outfileLabel.setText(RCPMessages.ComputeCoocMatrix_12);
+			outfileLabel.setLayoutData(new GridData(GridData.END, GridData.CENTER,
+					false, false));
+
+			Button outfileButton = new Button(composite, SWT.PUSH);
+			outfileButton.setText(RCPMessages.ComputeCoocMatrix_13);
+			outfileButton.addSelectionListener(new SelectionListener() {
+				@Override
+				public void widgetSelected(SelectionEvent e) {
+					FileDialog dialog = new FileDialog(e.display.getActiveShell(), SWT.SAVE);
+					String extensions[] = {"*.graphml"}; //$NON-NLS-1$
+					dialog.setFilterExtensions(extensions);
+					String path = dialog.open();
+					if (path != null) {
+						outfile = new File(path);
+						if (!(outfile.getName().toLowerCase().endsWith(".graphml"))) { //$NON-NLS-1$
+							outfile = new File(path+".graphml"); //$NON-NLS-1$
+						}
+						outfileLabel.setText(outfile.getAbsolutePath());
+					}
+				}
+
+				@Override
+				public void widgetDefaultSelected(SelectionEvent e) { }
+			});
+
+			return parent;
+		}
+
+		public File getOutFile() {
+			return outfile;
+		}
+
+		public int getDist() {
+			return dist;
+		}
+
+		public int getMin() {
+			return min;
+		}
+
+		public String getStruct() {
+			return struct;
+		}
+
+		/* (non-Javadoc)
+		 * @see org.eclipse.jface.dialogs.Dialog#okPressed()
+		 */
+		@Override
+		protected void okPressed() {
+			dist = distSpinner.getSelection();
+			min = minSpinner.getSelection();
+			struct = null;
+			oriented = orientedButton.getSelection();
+			for (int i : propsCombo.getSelectionIndices()) {
+				String sname = propsCombo.getItem(i);
+				if (sname != null && sname.length() > 0) {
+					struct = sname;
+					break;
+				}
+			}
+			super.okPressed();
+		}
+	}
+}

Index: tmp/org.txm.querycooccurrences.rcp/src/org/txm/rcp/commands/function/ComputeQueryCooccurrence.java
===================================================================
--- tmp/org.txm.querycooccurrences.rcp/src/org/txm/rcp/commands/function/ComputeQueryCooccurrence.java	(revision 0)
+++ tmp/org.txm.querycooccurrences.rcp/src/org/txm/rcp/commands/function/ComputeQueryCooccurrence.java	(revision 673)
@@ -0,0 +1,394 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate:$
+// $LastChangedRevision:$
+// $LastChangedBy:$ 
+//
+package org.txm.rcp.commands.function;
+
+import java.io.BufferedReader;
+import java.io.File;
+import java.io.FileInputStream;
+import java.io.IOException;
+import java.io.InputStreamReader;
+import java.util.ArrayList;
+
+import org.eclipse.core.commands.AbstractHandler;
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
+import org.eclipse.jface.dialogs.Dialog;
+import org.eclipse.jface.viewers.IStructuredSelection;
+import org.eclipse.jface.window.Window;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.events.SelectionEvent;
+import org.eclipse.swt.events.SelectionListener;
+import org.eclipse.swt.graphics.GC;
+import org.eclipse.swt.layout.GridData;
+import org.eclipse.swt.layout.GridLayout;
+import org.eclipse.swt.widgets.Button;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Control;
+import org.eclipse.swt.widgets.FileDialog;
+import org.eclipse.swt.widgets.Label;
+import org.eclipse.swt.widgets.Shell;
+import org.eclipse.swt.widgets.Spinner;
+import org.eclipse.ui.handlers.HandlerUtil;
+import org.txm.functions.coocmatrix.QueryCooccurrence;
+//import org.txm.functions.queryindex.*;
+import org.txm.rcp.JobsTimer;
+import org.txm.rcp.RCPMessages;
+import org.txm.rcp.utils.JobHandler;
+import org.txm.rcp.views.QueriesView;
+import org.txm.rcp.views.corpora.CorporaView;
+import org.txm.searchengine.cqp.CQPEngine;
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.StructuralUnit;
+import org.txm.searchengine.cqp.corpus.query.Query;
+import org.txm.statsengine.r.rcp.views.RVariablesView;
+import org.txm.utils.logger.Log;
+
+// TODO: Auto-generated Javadoc
+/**
+ * if the selection is a corpus, open an empty Cooc editor if the selection is a
+ * concordance, open a Cooc editor already computed @ author mdecorde.
+ */
+public class ComputeQueryCooccurrence extends AbstractHandler {
+
+	float reqtime = 0.5f;
+
+	/* (non-Javadoc)
+	 * @see org.eclipse.core.commands.AbstractHandler#execute(org.eclipse.core.commands.ExecutionEvent)
+	 */
+	@Override
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+		IStructuredSelection selection = (IStructuredSelection) HandlerUtil.getCurrentSelection(event);
+		final Object element = selection.getFirstElement();
+
+		final Shell shell = HandlerUtil.getActiveWorkbenchWindowChecked(event)
+				.getShell();
+
+		JobHandler jobhandler = new JobHandler("Computing cooccurrences matrix") {
+			@Override
+			protected IStatus run(IProgressMonitor monitor) {
+				this.runInit(monitor);
+				try {
+					JobsTimer.start();
+
+					if (!(element instanceof Corpus)) {
+						System.out.println(RCPMessages.ComputeCooccurrences_1+ element);
+						return Status.CANCEL_STATUS;
+					}
+					Corpus corpus = ((Corpus)element);
+
+					final CoocMatrixDialog dialog = new ComputeQueryCooccurrence.CoocMatrixDialog(shell, corpus);
+					syncExec(new Runnable() {
+						@Override
+						public void run() {
+							dialog.open();
+						}
+					});
+
+					if (dialog.getReturnCode() != Window.OK) System.out.println("Canceled");
+
+					this.acquireSemaphore();
+					final QueryCooccurrence cooc = computeCooc(shell, corpus, dialog);
+					this.releaseSemaphore();
+
+					if (cooc == null) return null;
+
+					System.out.println(RCPMessages.ComputeCoocMatrix_0+cooc.getSymbol());
+
+					syncExec(new Runnable() {
+						@Override
+						public void run() {
+							CorporaView.refresh();
+							CorporaView.expand(cooc.getCorpus());
+							QueriesView.refresh();
+							RVariablesView.refresh();
+						}
+					});
+				} catch (ThreadDeath td) { 
+					return Status.CANCEL_STATUS;
+				} catch (Exception e) {
+					Log.printStackTrace(e);
+					try { System.out.println(RCPMessages.LastCQPError+CQPEngine.getCqiClient().getLastCQPError());
+					} catch (Exception e1) { e1.printStackTrace(); }
+				} finally {
+					monitor.done();
+					JobsTimer.stopAndPrint();
+				}
+				return Status.OK_STATUS;
+			}
+		};
+		jobhandler.startJob();
+		return null;
+	}
+
+
+	private QueryCooccurrence computeCooc(Shell shell, Corpus corpus, CoocMatrixDialog dialog) throws IOException {
+		ArrayList<Query> queries1 = new ArrayList<Query>();
+		ArrayList<String> names1 = new ArrayList<String>();
+		ArrayList<Query> queries2 = new ArrayList<Query>();
+		ArrayList<String> names2 = new ArrayList<String>();
+
+		String struct = dialog.getStruct();
+		int dist = dialog.getDist();
+		int min = dialog.getMin();
+		getQueriesAndNames(dialog.getQueryFile1(), queries1, names1);
+		getQueriesAndNames(dialog.getQueryFile2(), queries2, names2);
+
+		System.out.println(RCPMessages.ProgressionDialog_8+queries1);
+		System.out.println(RCPMessages.MergeCols_5+names1);
+
+		QueryCooccurrence cooc = null;
+		try {
+			int nqueries = (queries1.size()*queries2.size());
+			System.out.println("Number of queries: "+nqueries);
+			System.out.println("Estimated time: "+(nqueries*reqtime/1000)+" secs");
+			cooc = new QueryCooccurrence(corpus, queries1, names1, queries2, names2, dist, min, struct);
+			System.out.println(RCPMessages.ComputeCoocMatrix_1+cooc.getNNodes());
+			System.out.println(RCPMessages.ComputeCoocMatrix_2+cooc.getNEdges());
+			System.out.println(RCPMessages.ComputeCoocMatrix_3+dist);
+		} catch (Exception e) {
+			// TODO Auto-generated catch block
+			Log.printStackTrace(e);
+			try { System.out.println(RCPMessages.LastCQPError+CQPEngine.getCqiClient().getLastCQPError());
+			} catch (Exception e1) { e1.printStackTrace(); }
+		}
+		return cooc;
+	}
+
+	private void getQueriesAndNames(File propFile, ArrayList<Query> queries,
+			ArrayList<String> names) throws IOException {
+		BufferedReader reader = new BufferedReader(new InputStreamReader(
+				new FileInputStream(propFile), "UTF-8")); //$NON-NLS-1$
+
+		String line = reader.readLine();
+		while (line != null) {
+			String[] split = line.split("=", 2); //$NON-NLS-1$
+			if (split.length == 2) {
+				queries.add(new Query(split[1]));
+				names.add(split[0]);
+			}
+
+			line = reader.readLine();
+		}
+		reader.close();
+	}
+
+	public class CoocMatrixDialog extends Dialog {
+		Corpus corpus;
+
+		org.eclipse.swt.widgets.List propsCombo;
+		Spinner distSpinner;
+		Spinner minSpinner;
+		Label queriesFile1Label;
+		Label queriesFile2Label;
+
+		File queriesFile1;
+		File queriesFile2;
+		int dist;
+		int min;
+		String struct;
+		private boolean oriented;
+
+		private Button orientedButton;
+
+
+
+		public CoocMatrixDialog(Shell parentShell, Corpus corpus) {
+			super(parentShell);
+			this.setShellStyle(this.getShellStyle() | SWT.RESIZE);
+			this.corpus = corpus;
+		}
+
+
+		public boolean getOriented() {
+			return oriented;
+		}
+
+
+		/* (non-Javadoc)
+		 * @see org.eclipse.jface.window.Window#configureShell(org.eclipse.swt.widgets.Shell)
+		 */
+		@Override
+		protected void configureShell(Shell newShell) {
+			super.configureShell(newShell);
+			newShell.setText(RCPMessages.ComputeCoocMatrix_7);
+		}
+
+		/* (non-Javadoc)
+		 * @see org.eclipse.jface.dialogs.Dialog#createDialogArea(org.eclipse.swt.widgets.Composite)
+		 */
+		@Override
+		protected Control createDialogArea(Composite parent) {
+			Composite composite = parent; //new Composite(parent, SWT.NONE);
+			// TODO : we just put a composite into another composite. Everything
+			// should be directly put into parent
+			GridLayout layout = new GridLayout(2, false);
+			composite.setLayout(layout);
+
+			Label anaPropLabel = new Label(composite, SWT.NONE);
+			anaPropLabel.setText(RCPMessages.ParaBrowserEditor_5);
+			anaPropLabel.setLayoutData(new GridData(GridData.END, GridData.CENTER, false, false));
+
+			propsCombo = new org.eclipse.swt.widgets.List(composite, SWT.READ_ONLY);
+			GridData gdata = new GridData(GridData.FILL, GridData.FILL, true, false);
+			propsCombo.setLayoutData(gdata);
+			GC gc = new GC(propsCombo);
+			gc.setFont(this.propsCombo.getFont());
+			gdata.heightHint = gc.getFontMetrics().getHeight() * 5;
+			gc.dispose();
+			propsCombo.add("");
+			try {
+				for (StructuralUnit p : corpus.getStructuralUnits()) {
+					if (!("text".equals(p.getName()) ||  //$NON-NLS-1$
+							"txmcorpus".equals(p.getName()))) //$NON-NLS-1$
+						propsCombo.add(p.getName());
+				}
+			} catch (CqiClientException e) {
+				Log.printStackTrace(e);
+				return parent;
+			}
+
+			Label distLabel = new Label(composite, SWT.NONE);
+			distLabel.setText(RCPMessages.ComputeCoocMatrix_10);
+			distLabel.setLayoutData(new GridData(GridData.END, GridData.CENTER,
+					false, false));
+			distSpinner = new Spinner(composite, SWT.BORDER);
+			distSpinner.setMinimum(0);
+			distSpinner.setMaximum(1000);
+			distSpinner.setSelection(10);
+
+			Label minLabel = new Label(composite, SWT.NONE);
+			minLabel.setText(RCPMessages.ComputeCoocMatrix_11);
+			minLabel.setLayoutData(new GridData(GridData.END, GridData.CENTER,
+					false, false));
+			minSpinner = new Spinner(composite, SWT.BORDER);
+			minSpinner.setMinimum(1);
+			minSpinner.setMaximum(1000);
+			minSpinner.setSelection(20);
+
+			Label orientedLabel = new Label(composite, SWT.NONE);
+			orientedLabel.setText("Oriented");
+			orientedLabel.setLayoutData(new GridData(GridData.END, GridData.CENTER,
+					false, false));
+			orientedButton = new Button(composite, SWT.CHECK);
+			orientedButton.setSelection(false);
+
+			queriesFile1Label = new Label(composite, SWT.NONE);
+			queriesFile1Label.setText("Query file 1");
+			queriesFile1Label.setLayoutData(new GridData(GridData.END, GridData.CENTER,
+					false, false));
+
+			Button queriesFile1Button = new Button(composite, SWT.PUSH);
+			queriesFile1Button.setText("Select...");
+			queriesFile1Button.addSelectionListener(new SelectionListener() {
+				@Override
+				public void widgetSelected(SelectionEvent e) {
+					FileDialog dialog = new FileDialog(e.display.getActiveShell(), SWT.OPEN);
+					String extensions[] = {"*.properties"}; //$NON-NLS-1$
+					dialog.setFilterExtensions(extensions);
+					String path = dialog.open();
+					if (path != null) {
+						queriesFile1 = new File(path);
+						queriesFile1Label.setText(queriesFile1.getAbsolutePath());
+					}
+				}
+
+				@Override
+				public void widgetDefaultSelected(SelectionEvent e) { }
+			});
+
+			queriesFile2Label = new Label(composite, SWT.NONE);
+			queriesFile2Label.setText("Query file 2");
+			queriesFile2Label.setLayoutData(new GridData(GridData.END, GridData.CENTER,
+					false, false));
+
+			Button queriesFile2Button = new Button(composite, SWT.PUSH);
+			queriesFile2Button.setText("Select...");
+			queriesFile2Button.addSelectionListener(new SelectionListener() {
+				@Override
+				public void widgetSelected(SelectionEvent e) {
+					FileDialog dialog = new FileDialog(e.display.getActiveShell(), SWT.OPEN);
+					String extensions[] = {"*.properties"}; //$NON-NLS-1$
+					dialog.setFilterExtensions(extensions);
+					String path = dialog.open();
+					if (path != null) {
+						queriesFile2 = new File(path);
+						queriesFile2Label.setText(queriesFile2.getAbsolutePath());
+					}
+				}
+
+				@Override
+				public void widgetDefaultSelected(SelectionEvent e) { }
+			});
+
+			return parent;
+		}
+
+		public File getQueryFile1() {
+			return queriesFile1;
+		}
+
+		public File getQueryFile2() {
+			return queriesFile2;
+		}
+
+		public int getDist() {
+			return dist;
+		}
+
+		public int getMin() {
+			return min;
+		}
+
+		public String getStruct() {
+			return struct;
+		}
+
+		/* (non-Javadoc)
+		 * @see org.eclipse.jface.dialogs.Dialog#okPressed()
+		 */
+		@Override
+		protected void okPressed() {
+			dist = distSpinner.getSelection();
+			min = minSpinner.getSelection();
+			struct = null;
+			oriented = orientedButton.getSelection();
+			for (int i : propsCombo.getSelectionIndices()) {
+				String sname = propsCombo.getItem(i);
+				if (sname != null && sname.length() > 0) {
+					struct = sname;
+					break;
+				}
+			}
+			super.okPressed();
+		}
+	}
+}

